import 'dart:convert';

import '../models/core_model.dart';
import '../utils/constants.dart';

class CoreDecoder {
  dynamic decoder({String? valKey, String? platform}) {
    try {
      String jsonString = utf8.decode(base64.decode(valKey!));
      Map<String, dynamic> object = jsonDecode(jsonString);
      final pkg = CoreModel.fromJson(object).package;
      return (pkg == platform || pkg.isEmpty) ? object : CoreModel.object;
    } catch (e) {
      throw Exception(
          'Invalid validation key, please contact support at ${Constants.supportUrl}');
    }
  }

  dynamic decoded(String validationKey, {String? decodedKey}) {
    String jsonString = utf8.decode(base64.decode(validationKey));
    Map<String, dynamic> jsonObject = jsonDecode(jsonString);
    return decodedKey ?? jsonObject;
  }
}
